using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZXDT.DBUtility;
using System.Data;
using System.Data.SqlClient;
using ZXDT.CallCenter.Model;

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_DictionaryBase
    /// </summary>
    public partial class T_Sys_DictionaryBase
    {
        public T_Sys_DictionaryBase()
        { }
        #region  BasicMethod

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_DictionaryFlag)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_DictionaryBase");
            strSql.Append(" where F_DictionaryFlag=@F_DictionaryFlag ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_DictionaryFlag", SqlDbType.VarChar,50)			};
            parameters[0].Value = F_DictionaryFlag;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(ZXDT.CallCenter.Model.T_Sys_DictionaryBase model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_DictionaryBase(");
            strSql.Append("F_DictionaryFlag,F_DictionaryName,F_Sort,F_Describe,F_State)");
            strSql.Append(" values (");
            strSql.Append("@F_DictionaryFlag,@F_DictionaryName,@F_Sort,@F_Describe,@F_State)");
            SqlParameter[] parameters = {
					new SqlParameter("@F_DictionaryFlag", SqlDbType.VarChar,50),
					new SqlParameter("@F_DictionaryName", SqlDbType.VarChar,50),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Describe", SqlDbType.VarChar,100),
					new SqlParameter("@F_State", SqlDbType.VarChar,20)};
            parameters[0].Value = model.F_DictionaryFlag;
            parameters[1].Value = model.F_DictionaryName;
            parameters[2].Value = model.F_Sort;
            parameters[3].Value = model.F_Describe;
            parameters[4].Value = model.F_State;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Sys_DictionaryBase model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_DictionaryBase set ");
            strSql.Append("F_DictionaryName=@F_DictionaryName,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_Describe=@F_Describe,");
            strSql.Append("F_State=@F_State");
            strSql.Append(" where F_DictionaryFlag=@F_DictionaryFlag ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_DictionaryName", SqlDbType.VarChar,50),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Describe", SqlDbType.VarChar,100),
					new SqlParameter("@F_State", SqlDbType.VarChar,20),
					new SqlParameter("@F_DictionaryFlag", SqlDbType.VarChar,50)};
            parameters[0].Value = model.F_DictionaryName;
            parameters[1].Value = model.F_Sort;
            parameters[2].Value = model.F_Describe;
            parameters[3].Value = model.F_State;
            parameters[4].Value = model.F_DictionaryFlag;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(string F_DictionaryFlag)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictionaryBase ");
            strSql.Append(" where F_DictionaryFlag=@F_DictionaryFlag ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_DictionaryFlag", SqlDbType.VarChar,50)			};
            parameters[0].Value = F_DictionaryFlag;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_DictionaryFlaglist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictionaryBase ");
            strSql.Append(" where F_DictionaryFlag in (" + F_DictionaryFlaglist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Sys_DictionaryBase GetModel(string F_DictionaryFlag)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_DictionaryFlag,F_DictionaryName,F_Sort,F_Describe,F_State from T_Sys_DictionaryBase ");
            strSql.Append(" where F_DictionaryFlag=@F_DictionaryFlag ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_DictionaryFlag", SqlDbType.VarChar,50)			};
            parameters[0].Value = F_DictionaryFlag;

            ZXDT.CallCenter.Model.T_Sys_DictionaryBase model = new ZXDT.CallCenter.Model.T_Sys_DictionaryBase();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Sys_DictionaryBase DataRowToModel(DataRow row)
        {
            ZXDT.CallCenter.Model.T_Sys_DictionaryBase model = new ZXDT.CallCenter.Model.T_Sys_DictionaryBase();
            if (row != null)
            {
                if (row["F_DictionaryFlag"] != null)
                {
                    model.F_DictionaryFlag = row["F_DictionaryFlag"].ToString();
                }
                if (row["F_DictionaryName"] != null)
                {
                    model.F_DictionaryName = row["F_DictionaryName"].ToString();
                }
                if (row["F_Sort"] != null && row["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(row["F_Sort"].ToString());
                }
                if (row["F_Describe"] != null)
                {
                    model.F_Describe = row["F_Describe"].ToString();
                }
                if (row["F_State"] != null)
                {
                    model.F_State = row["F_State"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_DictionaryFlag,F_DictionaryName,F_Sort,F_Describe,F_State ");
            strSql.Append(" FROM T_Sys_DictionaryBase ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_DictionaryFlag,F_DictionaryName,F_Sort,F_Describe,F_State ");
            strSql.Append(" FROM T_Sys_DictionaryBase ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_DictionaryBase ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_DictionaryFlag desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_DictionaryBase T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }



        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod

        #region 获取树结构
        /// <summary>
        ///  获得当前节点下的所有子集以tree的格式
        /// </summary>
        public TreeNodeStrModel GetDictionaryJsonModel()
        {
            TreeNodeStrModel returnModel = new TreeNodeStrModel();
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Sys_DictionaryBase order by F_Sort asc");

            DataSet ds = DbHelperSQL.Query(strSql.ToString());

            if (ds != null && ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
            {

                TreeNodeStrModel model = new TreeNodeStrModel();
                List<TreeNodeStrModel> modelList = new List<TreeNodeStrModel>();
                model.id = "0";
                model.name = "字典项列表";
                model.code = "0";
                model.iconClose = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_close.png";
                model.iconOpen = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_open.png";
                model.open = "true";
                model.children = modelList;
                returnModel = GetTreeModel(ds.Tables[0], model);

            }
            return returnModel;
        }


        /// <summary>
        /// 获取chlid
        /// </summary>
        /// <param name="table">数据结合</param>
        /// <param name="model">当前model</param>
        /// <returns></returns>
        public TreeNodeStrModel GetTreeModel(DataTable table, TreeNodeStrModel model)
        {
            foreach (DataRow row in table.Rows)
            {
                List<TreeNodeStrModel> modelList = new List<TreeNodeStrModel>();
                TreeNodeStrModel childModel = new TreeNodeStrModel();
                childModel.id = row["F_DictionaryFlag"].ToString();
                childModel.name = row["F_DictionaryName"].ToString();
                childModel.code = row["F_DictionaryFlag"].ToString();
                childModel.iconClose = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_close.png";
                childModel.iconOpen = "../../Content/layui/zTree/v3/css/zTreeStyle/img/diy/1_open.png";
                childModel.open = "true";
                childModel.children = modelList;
                model.children.Add(childModel);
               
            }

            return model;

        }

        #endregion


    }



}
